Index: trunk/Include/api_window.sbp
===================================================================
--- trunk/Include/api_window.sbp	(revision 303)
+++ trunk/Include/api_window.sbp	(revision 324)
@@ -79,4 +79,9 @@
 Const _FuncName_wsprintf = "wsprintfW"
 Const _FuncName_wvsprintf = "wvsprintfW"
+Const _FuncName_ChangeDisplaySettings = "ChangeDisplaySettingsW"
+Const _FuncName_ChangeDisplaySettingsEx= "ChangeDisplaySettingsExW"
+Const _FuncName_EnumDisplaySettings= "EnumDisplaySettingsW"
+Const _FuncName_EnumDisplaySettingsEx= "EnumDisplaySettingsExW"
+Const _FuncName_EnumDisplayDevices= "EnumDisplayDevicesW"
 #else
 Const _FuncName_CallWindowProc = "CallWindowProcA"
@@ -151,4 +156,9 @@
 Const _FuncName_wsprintf = "wsprintfA"
 Const _FuncName_wvsprintf = "wvsprintfA"
+Const _FuncName_ChangeDisplaySettings = "ChangeDisplaySettingsA"
+Const _FuncName_ChangeDisplaySettingsEx= "ChangeDisplaySettingsExA"
+Const _FuncName_EnumDisplaySettings= "EnumDisplaySettingsA"
+Const _FuncName_EnumDisplaySettingsEx= "EnumDisplaySettingsExA"
+Const _FuncName_EnumDisplayDevices= "EnumDisplayDevicesA"
 #endif
 
@@ -1402,4 +1412,71 @@
 Declare Function SystemParametersInfo Lib "user32" Alias _FuncName_SystemParametersInfo (uiAction As DWord, uiParam As DWord, pvParam As VoidPtr, fWinIni As DWord) As BOOL
 
+Const CDS_UPDATEREGISTRY = &H00000001
+Const CDS_TEST            = &H00000002
+Const CDS_FULLSCREEN      = &H00000004
+Const CDS_GLOBAL          = &H00000008
+Const CDS_SET_PRIMARY     = &H00000010
+Const CDS_VIDEOPARAMETERS = &H00000020
+Const CDS_RESET           = &H40000000
+Const CDS_NORESET         = &H10000000
+
+Const DISP_CHANGE_SUCCESSFUL    =   0
+Const DISP_CHANGE_RESTART       =   1
+Const DISP_CHANGE_FAILED        =  -1
+Const DISP_CHANGE_BADMODE       =  -2
+Const DISP_CHANGE_NOTUPDATED    =  -3
+Const DISP_CHANGE_BADFLAGS      =  -4
+Const DISP_CHANGE_BADPARAM      =  -5
+Const DISP_CHANGE_BADDUALVIEW   =  -6
+
+#ifdef _INC_GDI
+Declare Function ChangeDisplaySettingsA Lib "user32" (ByVal lpDevMode As *DEVMODEA, ByVal dwFlags As DWord) As Long
+Declare Function ChangeDisplaySettingsW Lib "user32" (ByVal lpDevMode As *DEVMODEW, ByVal dwFlags As DWord) As Long
+#ifdef UNICODE
+Declare Function ChangeDisplaySettings Lib "user32" Alias _FuncName_ChangeDisplaySettings (ByVal lpDevMode As *DEVMODEW, ByVal dwFlags As DWord) As Long
+#else
+Declare Function ChangeDisplaySettings Lib "user32" Alias _FuncName_ChangeDisplaySettings (ByVal lpDevMode As *DEVMODEA, ByVal dwFlags As DWord) As Long
+#endif
+
+Declare Function ChangeDisplaySettingsExA Lib "user32" (ByVal lpszDeviceName As LPCSTR, ByVal lpDevMode As *DEVMODEA, ByVal hwnd As HWND, ByVal dwFlags As DWord, ByVal lParam As VoidPtr) As Long
+Declare Function ChangeDisplaySettingsExW Lib "user32" (ByVal lpszDeviceName As LPCWSTR, ByVal lpDevMode As *DEVMODEW, ByVal hwnd As HWND, ByVal dwFlags As DWord, ByVal lParam As VoidPtr) As Long
+#ifdef UNICODE
+Declare Function ChangeDisplaySettingsEx Lib "user32" Alias _FuncName_ChangeDisplaySettingsEx (ByVal lpszDeviceName As LPCWSTR, ByVal lpDevMode As *DEVMODEW, ByVal hwnd As HWND, ByVal dwFlags As DWord, ByVal lParam As VoidPtr) As Long
+#else
+Declare Function ChangeDisplaySettingsEx Lib "user32" Alias _FuncName_ChangeDisplaySettingsEx (ByVal lpszDeviceName As LPCSTR, ByVal lpDevMode As *DEVMODEA, ByVal hwnd As HWND, ByVal dwFlags As DWord, ByVal lParam As VoidPtr) As Long
+#endif
+
+Const ENUM_CURRENT_SETTINGS       = ((-1) As DWord)
+Const ENUM_REGISTRY_SETTINGS      = ((-2) As DWord)
+
+Declare Function EnumDisplaySettingsA Lib "user32" (ByVal lpszDeviceName As LPCSTR, ByVal iModeNum As DWord, ByVal lpDevMode As *DEVMODEA) As BOOL
+Declare Function EnumDisplaySettingsW Lib "user32" (ByVal lpszDeviceName As LPCWSTR, ByVal iModeNum As DWord, ByVal lpDevMode As *DEVMODEW) As BOOL
+#ifdef UNICODE
+Declare Function EnumDisplaySettings Lib "user32" Alias _FuncName_EnumDisplaySettings (ByVal lpszDeviceName As LPCWSTR, ByVal iModeNum As DWord, ByVal lpDevMode As *DEVMODEW) As BOOL
+#else
+Declare Function EnumDisplaySettings Lib "user32" Alias _FuncName_EnumDisplaySettings (ByVal lpszDeviceName As LPCSTR, ByVal iModeNum As DWord, ByVal lpDevMode As *DEVMODEA) As BOOL
+#endif
+
+/*#ifdef(WINVER >= 0x0500)
+Declare Function EnumDisplaySettingsExA Lib "user32" (ByVal lpszDeviceName As LPCSTR, ByVal iModeNum As DWord, ByVal lpDevMode As *DEVMODEA, ByVal dwFlags As DWord) As BOOL
+Declare Function EnumDisplaySettingsExW Lib "user32" (ByVal lpszDeviceName As LPCWSTR, ByVal iModeNum As DWord, ByVal lpDevMode As *DEVMODEW, ByVal dwFlags As DWord) As BOOL
+#ifdef UNICODE
+Declare Function EnumDisplaySettingsEx Lib "user32" Alias _FuncName_EnumDisplaySettingsEx (ByVal lpszDeviceName As LPCWSTR, ByVal iModeNum As DWord, ByVal lpDevMode As *DEVMODEW, ByVal dwFlags As DWord) As BOOL
+#else
+Declare Function EnumDisplaySettingsEx Lib "user32" Alias _FuncName_EnumDisplaySettingsEx (ByVal lpszDeviceName As LPCSTR, ByVal iModeNum As DWord, ByVal lpDevMode As *DEVMODEA, ByVal dwFlags As DWord) As BOOL
+#endif
+
+Const EDS_RAWMODE  = &H00000002
+
+Declare Function EnumDisplayDevicesA Lib "user32" (ByVal lpDevice As LPCSTR, ByVal iDevNum As DWord, ByVal lpDisplayDevice As *DISPLAY_DEVICEA, ByVal dwFlags As DWord) As BOOL
+Declare Function EnumDisplayDevicesW Lib "user32" (ByVal lpDevice As LPCWSTR, ByVal iDevNum As DWord, ByVal lpDisplayDevice As *DISPLAY_DEVICEW, ByVal dwFlags As DWord)As BOOL
+#ifdef UNICODE
+Declare Function EnumDisplayDevices Lib "user32" Alias _FuncName_EnumDisplayDevices (ByVal lpDevice As LPCWSTR, ByVal iDevNum As DWord, ByVal lpDisplayDevice As *DISPLAY_DEVICEW, ByVal dwFlags As DWord)As BOOL
+#else
+Declare Function EnumDisplayDevices Lib "user32" Alias _FuncName_EnumDisplayDevices (ByVal lpDevice As LPCSTR, ByVal iDevNum As DWord, ByVal lpDisplayDevice As *DISPLAY_DEVICEA, ByVal dwFlags As DWord) As BOOL
+#endif
+#endif */ /* WINVER >= 0x0500 */
+#endif ' _INC_GDI
+
 Const TME_HOVER       = &H00000001
 Const TME_LEAVE       = &H00000002
@@ -1429,5 +1506,5 @@
 Const TPM_RETURNCMD =    &H0100
 Const TPM_RECURSE =      &H0001
-Declare Function TrackPopupMenu Lib "user32" (hMenu As HMENU, uFlags As DWord, x As Long, y As Long, nReserved As Long, hWnd As HWND, ByRef prcRect As RECT) As BOOL
+Declare Function TrackPopupMenu Lib "user32" (hMenu As HMENU, uFlags As DWord, x As Long, y As Long, nReserved As Long, ByVal hWnd As HWND, ByRef prcRect As RECT) As BOOL
 
 declare function UnhookWindowsHookEx lib "user32" (ByVal hhk As HHOOK) As BOOL